searchNodes=[{"doc":"","ref":"PolymorphicEmbed.html","title":"PolymorphicEmbed","type":"module"},{"doc":"","ref":"PolymorphicEmbed.html#cast_polymorphic_embed/3","title":"PolymorphicEmbed.cast_polymorphic_embed/3","type":"function"},{"doc":"","ref":"PolymorphicEmbed.html#do_load/3","title":"PolymorphicEmbed.do_load/3","type":"function"},{"doc":"","ref":"PolymorphicEmbed.html#get_polymorphic_module/3","title":"PolymorphicEmbed.get_polymorphic_module/3","type":"function"},{"doc":"","ref":"PolymorphicEmbed.html#get_polymorphic_type/3","title":"PolymorphicEmbed.get_polymorphic_type/3","type":"function"},{"doc":"","ref":"PolymorphicEmbed.html#traverse_errors/2","title":"PolymorphicEmbed.traverse_errors/2","type":"function"},{"doc":"Returns the possible types for a given schema and field you can call types/2 like this: PolymorphicEmbed . types ( MySchema , :contexts ) #=&gt; [:location, :age, :device]","ref":"PolymorphicEmbed.html#types/2","title":"PolymorphicEmbed.types/2","type":"function"},{"doc":"","ref":"PolymorphicEmbed.HTML.Form.html","title":"PolymorphicEmbed.HTML.Form","type":"module"},{"doc":"Returns the polymorphic type of the given field in the given form data.","ref":"PolymorphicEmbed.HTML.Form.html#get_polymorphic_type/3","title":"PolymorphicEmbed.HTML.Form.get_polymorphic_type/3","type":"function"},{"doc":"Generates a new form builder without an anonymous function. Similarly to Phoenix.HTML.Form.inputs_for/3 , this function exists for integration with Phoenix.LiveView . Unlike polymorphic_embed_inputs_for/4 , this function does not generate hidden inputs. Example &lt; . form let = { f } for = { @changeset } id = &quot;reminder-form&quot; phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; % = for channel_form &lt;- polymorphic_embed_inputs_for f , :channel do % &gt; &lt; % = hidden_inputs_for ( channel_form ) % &gt; &lt; % = case get_polymorphic_type ( channel_form , Reminder , :channel ) do % &gt; &lt; % :sms -&gt; % &gt; &lt; % = label channel_form , :number % &gt; &lt; % = text_input channel_form , :number % &gt; &lt; % :email -&gt; % &gt; &lt; % = label channel_form , :email % &gt; &lt; % = text_input channel_form , :email % &gt; &lt; % end % &gt; &lt; / . form &gt;","ref":"PolymorphicEmbed.HTML.Form.html#polymorphic_embed_inputs_for/2","title":"PolymorphicEmbed.HTML.Form.polymorphic_embed_inputs_for/2","type":"function"},{"doc":"Like polymorphic_embed_inputs_for/4 , but determines the type from the form data. Example &lt; % = inputs_for f , :reminders , fn reminder_form -&gt; % &gt; &lt; % = polymorphic_embed_inputs_for reminder_form , :channel , fn channel_form -&gt; % &gt; &lt; % = case get_polymorphic_type ( channel_form , Reminder , :channel ) do % &gt; &lt; % :sms -&gt; % &gt; &lt; % = label poly_form , :number % &gt; &lt; % = text_input poly_form , :number % &gt; &lt; % :email -&gt; % &gt; &lt; % = label poly_form , :email % &gt; &lt; % = text_input poly_form , :email % &gt; &lt; % end % &gt; &lt; % end % &gt; &lt; % end % &gt; While polymorphic_embed_inputs_for/4 renders empty fields if the data is nil , this function does not. Instead, you can initialize your changeset to render an empty fieldset: changeset = reminder_changeset ( % Reminder { } , %{ &quot;channel&quot; =&gt; %{ &quot;__type__&quot; =&gt; &quot;sms&quot; } } )","ref":"PolymorphicEmbed.HTML.Form.html#polymorphic_embed_inputs_for/3","title":"PolymorphicEmbed.HTML.Form.polymorphic_embed_inputs_for/3","type":"function"},{"doc":"","ref":"PolymorphicEmbed.HTML.Form.html#polymorphic_embed_inputs_for/4","title":"PolymorphicEmbed.HTML.Form.polymorphic_embed_inputs_for/4","type":"function"},{"doc":"","ref":"PolymorphicEmbed.HTML.Form.html#to_form/5","title":"PolymorphicEmbed.HTML.Form.to_form/5","type":"function"},{"doc":"polymorphic_embed brings support for polymorphic/dynamic embedded schemas in Ecto. Ecto's embeds_one and embeds_many macros require a specific schema module to be specified. This library removes this restriction by dynamically determining which schema to use, based on data to be stored (from a form or API) and retrieved (from the data source).","ref":"readme.html","title":"Polymorphic embeds for Ecto","type":"extras"},{"doc":"Enable polymorphism Let's say we want a schema Reminder representing a reminder for an event, that can be sent either by email or SMS. We create the Email and SMS embedded schemas containing the fields that are specific for each of those communication channels. The Reminder schema can then contain a :channel field that will either hold an Email or SMS struct, by setting its type to the custom type PolymorphicEmbed that this library provides. Find the schema code and explanations below. defmodule MyApp.Reminder do use Ecto.Schema import Ecto.Changeset import PolymorphicEmbed , only : [ cast_polymorphic_embed : 3 ] schema &quot;reminders&quot; do field :date , :utc_datetime field :text , :string field :channel , PolymorphicEmbed , types : [ sms : MyApp.Channel.SMS , email : [ module : MyApp.Channel.Email , identify_by_fields : [ :address , :confirmed ] ] ] , on_type_not_found : :raise , on_replace : :update end def changeset ( struct , values ) do struct |&gt; cast ( values , [ :date , :text ] ) |&gt; cast_polymorphic_embed ( :channel , required : true ) |&gt; validate_required ( :date ) end end defmodule MyApp.Channel.Email do use Ecto.Schema import Ecto.Changeset @primary_key false embedded_schema do field :address , :string field :confirmed , :boolean end def changeset ( email , params ) do email |&gt; cast ( params , ~w(address confirmed)a ) |&gt; validate_required ( :address ) |&gt; validate_length ( :address , min : 4 ) end end defmodule MyApp.Channel.SMS do use Ecto.Schema @primary_key false embedded_schema do field :number , :string end end cast_polymorphic_embed/3 cast_polymorphic_embed/3 must be called to cast the polymorphic embed's parameters. Options :required – if the embed is a required field. :with – allows you to specify a custom changeset. Either pass an MFA or a function: changeset |&gt; cast_polymorphic_embed ( :channel , with : [ sms : { SMS , :custom_changeset , [ &quot;hello&quot; ] } , email : &amp; Email . custom_changeset / 2 ] ) PolymorphicEmbed Ecto type The :types option for the PolymorphicEmbed custom type contains a keyword list mapping an atom representing the type (in this example :email and :sms ) with the corresponding embedded schema module. There are two strategies to detect the right embedded schema to use: 1. [ sms : MyApp.Channel.SMS ] When receiving parameters to be casted (e.g. from a form), we expect a &quot;__type__&quot; (or :__type__ ) parameter containing the type of channel ( &quot;email&quot; or &quot;sms&quot; ). 2. [ email : [ module : MyApp.Channel.Email , identify_by_fields : [ :address , :confirmed ] ] ] Here we specify how the type can be determined based on the presence of given fields. In this example, if the data contains :address and :confirmed parameters (or their string version), the type is :email . A &quot;__type__&quot; parameter is then no longer required. Note that you may still include a __type__ parameter that will take precedence over this strategy (this could still be useful if you need to store incomplete data, which might not allow identifying the type). List of polymorphic embeds Lists of polymorphic embeds are also supported: field :contexts , { :array , PolymorphicEmbed } , types : [ location : MyApp.Context.Location , age : MyApp.Context.Age , device : MyApp.Context.Device ] , on_type_not_found : :raise , on_replace : :delete Options :types – discussed above. :type_field – specify a custom type field. Defaults to :__type__ . :on_type_not_found – specify what to do if the embed's type cannot be inferred. Possible values are :raise : raise an error :changeset_error : add a changeset error :nilify : replace the data by nil ; only for single (non-list) embeds :ignore : ignore the data; only for lists of embeds By default, a changeset error &quot;is invalid&quot; is added. :on_replace – mandatory option that can only be set to :update for a single embed and :delete for a list of embeds (we force a value as the default value of this option for embeds_one and embeds_many is :raise ). Displaying form inputs and errors in Phoenix templates The library comes with a form helper in order to build form inputs for polymorphic embeds and display changeset errors. In the entrypoint defining your web interface ( lib/your_app_web.ex file), add the following import: def view do quote do # imports and stuff import PolymorphicEmbed.HTML.Form end end This provides you with the polymorphic_embed_inputs_for/3 and polymorphic_embed_inputs_for/4 functions. Here is an example form using the imported function: &lt; % = inputs_for f , :reminders , fn reminder_form -&gt; % &gt; &lt; % = polymorphic_embed_inputs_for reminder_form , :channel , :sms , fn sms_form -&gt; % &gt; &lt; div class = &quot;sms-inputs&quot; &gt; &lt; label &gt; Number &lt; label &gt; &lt; % = text_input sms_form , :number % &gt; &lt; div class = &quot;error&quot; &gt; &lt; % = error_tag sms_form , :number % &gt; &lt; / div &gt; &lt; / div &gt; &lt; % end % &gt; &lt; % end % &gt; When using polymorphic_embed_inputs_for/4 , you have to manually specify the type. When the embed is nil , empty fields will be displayed. polymorphic_embed_inputs_for/3 doesn't require the type to be specified. When the embed is nil , no fields are displayed. They both render a hidden input for the &quot;__type__&quot; field. Displaying form inputs and errors in LiveView You may use polymorphic_embed_inputs_for/2 when working with LiveView. &lt; . form let = { f } for = { @changeset } id = &quot;reminder-form&quot; phx - change = &quot;validate&quot; phx - submit = &quot;save&quot; &gt; &lt; % = for channel_form &lt;- polymorphic_embed_inputs_for f , :channel do % &gt; &lt; % = hidden_inputs_for ( channel_form ) % &gt; &lt; % = case get_polymorphic_type ( channel_form , Reminder , :channel ) do % &gt; &lt; % :sms -&gt; % &gt; &lt; % = label channel_form , :number % &gt; &lt; % = text_input channel_form , :number % &gt; &lt; % :email -&gt; % &gt; &lt; % = label channel_form , :email % &gt; &lt; % = text_input channel_form , :email % &gt; &lt; % end % &gt; &lt; / . form &gt; Using this function, you have to render the necessary hidden inputs manually as shown above. Get the type of a polymorphic embed Sometimes you need to serialize the polymorphic embed and, once in the front-end, need to distinguish them. get_polymorphic_type/3 returns the type of the polymorphic embed: PolymorphicEmbed . get_polymorphic_type ( Reminder , :channel , SMS ) == :sms traverse_errors/2 The function Ecto.changeset.traverse_errors/2 won't include the errors of polymorphic embeds. You may instead use PolymorphicEmbed.traverse_errors/2 when working with polymorphic embeds.","ref":"readme.html#usage","title":"Polymorphic embeds for Ecto - Usage","type":"extras"},{"doc":"Detect which types to use for the data being cast -ed, based on fields present in the data (no need for a type field in the data) Run changeset validations when a changeset/2 function is present (when absent, the library will introspect the fields to cast) Support for nested polymorphic embeds Support for nested embeds_one / embeds_many embeds Display form inputs for polymorphic embeds in Phoenix templates Tests to ensure code quality","ref":"readme.html#features","title":"Polymorphic embeds for Ecto - Features","type":"extras"},{"doc":"Add polymorphic_embed for Elixir as a dependency in your mix.exs file: def deps do [ { :polymorphic_embed , &quot;~&gt; 1.10.0&quot; } ] end","ref":"readme.html#installation","title":"Polymorphic embeds for Ecto - Installation","type":"extras"},{"doc":"HexDocs documentation can be found at https://hexdocs.pm/polymorphic_embed .","ref":"readme.html#hexdocs","title":"Polymorphic embeds for Ecto - HexDocs","type":"extras"}]